Mesh to Part/ru: Difference between revisions

From FreeCAD Documentation
mNo edit summary
(Updating to match new version of source page)
Line 1: Line 1:
== Converting Part objects to Meshes ==
== Преобразование Part объектов в Полигиональную сетку ==

Конвертация высоко-уровневых объектов, таких как [[Part Module|формы Part(Деталей)]] в простые объекты такие как [[Mesh Module|полигиональные сетки]] это довольно простая операция, когда все грани Детали разбиваются на треугольники . Результат этой триангуляции затем используется для построения сетки:


Converting higher-level objects such as [[Part Module|Part shapes]] into simpler objects such as [[Mesh Module|meshes]] is a pretty simple operation, where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh: (let's assume our document contains one part object)
<syntaxhighlight>
#let's assume our document contains one part object
#let's assume our document contains one part object
import Mesh
import Mesh
Line 16: Line 16:
m = Mesh.Mesh(faces)
m = Mesh.Mesh(faces)
Mesh.show(m)
Mesh.show(m)
</syntaxhighlight>

Sometimes the triangulation of certain faces offered by OpenCascade is quite ugly. If the face has a rectangular parameter space and doesn't contain any holes or other trimming curves you can also create a mesh on your own:
Иногда, триангуляция определенной грани, предлагаемая OpenCascade очень уродлива. Если грань Если грань принадлежит к множеству многоугольников и не содержит любых отверстий или других обрезанных кривых, вы также можете создать сетку по вашему усмотрению:
<syntaxhighlight>

import Mesh
import Mesh
def makeMeshFromFace(u,v,face):
def makeMeshFromFace(u,v,face):
Line 37: Line 37:
return mesh
return mesh


</syntaxhighlight>
== Преобразование Сетки в Part объект ==
== Converting Meshes to Part objects ==


Converting Meshes to Part objects is an extremely important operation in CAD work, because very often you receive 3D data in mesh format from other people or outputted from other applications. Meshes are very practical to represent free-form geometry and big visual scenes, as it is very lightweight, but for CAD we generally prefer higher-level objects that carry much more information, such as the idea of solid, or faces made of curves instead of triangles.
Преобразование полигиональной сетки в Деталь черезвычайно важная операция в работе CAD, потому что очень часто вы получаете, от других людей или на выходе из других приложений, 3D данные в полигиональном виде. Сетки это очень практичны для представления геометрии свободной формы и больших визуальных сцен, так как они очень легковесны, но в CAD мы в основном предпочитаем высокоуровневые объекты, которые несут гораздо больше информации, таких как идеии твердых тел, или грани созданой из кривых а не труегольников.


Converting meshes to those higher-level objects (handled by the [[Part Module]] in FreeCAD) is not an easy operation. Meshes can be made of thousands of triangles (for example when generated by a 3D scanner), and having solids made of the same number of faces would be extremely heavy to manipulate. So you generally want to optimize the object when converting.
Преобразование сетки в высокоуровневый объект (занимается в FreeCAD [[Part Module/ru|Модуль Деталей]]) это не простая операция. Сетки могут состоять из тысяч треугольников (например когда, сгенерированы 3D сканером), и телом состоящим из того же числа граней, будет черезвычайно сложно управлять. Поэтому вы хотите оптимизировать объект при преобразовании.

В настоящее время FreeCAD предлагает два метода для преобразования Полигиональной Сетки в Деталь. Первый метод прост, это прямое преобразование, без какой либо оптимизации:


FreeCAD currently offers two methods to convert Meshes to Part objects. The first method is a simple, direct conversion, without any optimization:
<syntaxhighlight>
import Mesh,Part
import Mesh,Part
mesh = Mesh.createTorus()
mesh = Mesh.createTorus()
Line 52: Line 53:
Part.show(solid)
Part.show(solid)


</syntaxhighlight>
Второй метод позволяет учитывать какие грани сетки компланарны, когда угол между ними принимает определенное значение. Это позволяет строить формы попроще:
The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes: (let's assume our document contains one Mesh object)

<syntaxhighlight>
# let's assume our document contains one Mesh object
# let's assume our document contains one Mesh object
import Mesh,Part,MeshPart
import Mesh,Part,MeshPart
Line 87: Line 89:
#Part.show(solid)
#Part.show(solid)


</syntaxhighlight>
{{docnav/ru|Topological data scripting/ru|Scenegraph/ru}}
{{docnav|Topological data scripting|Scenegraph}}


[[Category:Poweruser Documentation]]
{{languages/ru | {{en|Mesh to Part}} {{es|Mesh to Part/es}} {{fr|Mesh to Part/fr}} {{it|Mesh to Part/it}} {{se|Mesh to Part/se}} }}
[[Category:Python Code]]


{{clear}}
[[Category:Poweruser Documentation/ru]]
<languages/>

Revision as of 20:42, 30 September 2014

Converting Part objects to Meshes

Converting higher-level objects such as Part shapes into simpler objects such as meshes is a pretty simple operation, where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh: (let's assume our document contains one part object)

 #let's assume our document contains one part object
 import Mesh
 faces = []
 shape = FreeCAD.ActiveDocument.ActiveObject.Shape
 triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
 for tri in triangles[1]:
     face = []
     for i in range(3):
         vindex = tri[i]
         face.append(triangles[0][vindex])
     faces.append(face)
 m = Mesh.Mesh(faces)
 Mesh.show(m)

Sometimes the triangulation of certain faces offered by OpenCascade is quite ugly. If the face has a rectangular parameter space and doesn't contain any holes or other trimming curves you can also create a mesh on your own:

 import Mesh
 def makeMeshFromFace(u,v,face):
 	(a,b,c,d)=face.ParameterRange
 	pts=[]
 	for j in range(v):
 		for i in range(u):
 			s=1.0/(u-1)*(i*b+(u-1-i)*a)
 			t=1.0/(v-1)*(j*d+(v-1-j)*c)
 			pts.append(face.valueAt(s,t))
 
 	mesh=Mesh.Mesh()
 	for j in range(v-1):
 		for i in range(u-1):
 			mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
 			mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])
 
 	return mesh

Converting Meshes to Part objects

Converting Meshes to Part objects is an extremely important operation in CAD work, because very often you receive 3D data in mesh format from other people or outputted from other applications. Meshes are very practical to represent free-form geometry and big visual scenes, as it is very lightweight, but for CAD we generally prefer higher-level objects that carry much more information, such as the idea of solid, or faces made of curves instead of triangles.

Converting meshes to those higher-level objects (handled by the Part Module in FreeCAD) is not an easy operation. Meshes can be made of thousands of triangles (for example when generated by a 3D scanner), and having solids made of the same number of faces would be extremely heavy to manipulate. So you generally want to optimize the object when converting.

FreeCAD currently offers two methods to convert Meshes to Part objects. The first method is a simple, direct conversion, without any optimization:

 import Mesh,Part
 mesh = Mesh.createTorus()
 shape = Part.Shape()
 shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
 solid = Part.makeSolid(shape)
 Part.show(solid)

The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes: (let's assume our document contains one Mesh object)

 # let's assume our document contains one Mesh object
 import Mesh,Part,MeshPart
 faces = []
 mesh = App.ActiveDocument.ActiveObject.Mesh
 segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
 for i in segments:
   if len(i) > 0:
      # a segment can have inner holes
      wires = MeshPart.wireFromSegment(mesh, i)
      # we assume that the exterior boundary is that one with the biggest bounding box
      if len(wires) > 0:
         ext=None
         max_length=0
         for i in wires:
            if i.BoundBox.DiagonalLength > max_length:
               max_length = i.BoundBox.DiagonalLength
               ext = i
 
         wires.remove(ext)
         # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
         for i in wires:
            i.reverse()
 
         # make sure that the exterior wires comes as first in the lsit
         wires.insert(0, ext)
         faces.append(Part.Face(wires))
 
 shell=Part.Compound(faces)
 Part.show(shell)
 #solid = Part.Solid(Part.Shell(faces))
 #Part.show(solid)
Topological data scripting
Scenegraph